import json
import os
import re
import shutil
import sys

import maya.mel as mel
from os import path as p
from sys import platform as _platform

work_dir = p.dirname(__file__)
if work_dir not in sys.path:
    sys.path.insert(0, work_dir)

import add_menu_icons
# reload(add_menu_icons)


def j(*arg):
    return os.path.join(*arg).replace('\\', '/').replace('//', '/')


def recursive_overwrite(src, dest, ignore=None, move=False, ignore_time=False):
    # print src, '->', dest
    if p.isdir(src):
        if not p.isdir(dest):
            os.makedirs(dest)
        files = os.listdir(src)
        if ignore is not None:
            ignored = ignore(src, files)
        else:
            ignored = set()
        for f in files:
            if f not in ignored:
                recursive_overwrite(j(src, f),
                                    j(dest, f),
                                    ignore=ignore,
                                    move=move,
                                   )
        if move and not os.listdir(src):
            os.rmdir(src)
    else:
        if p.isfile(dest) and not ignore_time:
            if os.path.getmtime(src) < os.path.getmtime(dest):
                return
        if move:
            shutil.move(src, dest)
        else:
            # print(src, dest)
            shutil.copy2(src, dest)
        # print src


def get_os():
    if _platform == "linux" or _platform == "linux2":
        osf = "lin"
    elif _platform == "win32" or _platform == "win64":
        osf = "win"
    else:
        osf = "mac"
    return osf


def main():
    install_dir = os.path.dirname(__file__)
    print('install_dir', install_dir)
    user_dir = p.expanduser('~')
    print( get_os())
    if get_os() == 'win':
        if not user_dir.endswith('Documents'):
            user_dir += '/Documents'
    print('user_dir', user_dir)
    maya_script = j(user_dir, 'maya', 'scripts')
    print('maya_script', maya_script)
    src = install_dir
    print('src', src)

    ver_folder = ''
    dest = j(maya_script, 'PickerBuilder')
    print('dest', dest)
    for x in os.listdir(src):
        if os.path.isdir(j(src, x)):
            if re.match("v\d\.\d+", x):
                ver_folder = x
            recursive_overwrite(j(src, x), j(dest, x), ignore_time=True)

    config_scr = j(src, ver_folder, 'config.dat')
    config_trg = j(dest, 'config.dat')
    recursive_overwrite(config_scr, config_trg, ignore_time=True)

    add_menu_icons.add_menu_pb()
    add_menu_icons.add_icons_pb()

    print('installing  Picker Builder finish!')



