import sys
import os
import glob
from sys import platform as _platform
from os import path as p

pb = 'PickerBuilder'
ad = 'autodesk'


def j(*arg):
    return os.path.join(*arg).replace('\\', '/').replace('//', '/')

def get_os():
    if _platform == "linux" or _platform == "linux2":
        osf = "lin"
    elif _platform == "win32" or _platform == "win64":
        osf = "win"
    else:
        osf = "mac"
    return osf

def get_ad_pb_path():
    for p in os.environ.get('PYTHONPATH').split(os.path.pathsep):
        if pb in p and ad in p.lower():
            ad_pb_path = os.path.join(p, pb)
            if os.path.isdir(ad_pb_path):
                return ad_pb_path


def get_user_pb_path():
    user_dir = p.expanduser('~')
    if get_os() == 'win':
        if not user_dir.endswith('Documents'):
            user_dir += '/Documents'
    pb_path = j(user_dir, 'maya', 'scripts', pb)
    if os.path.isdir(pb_path):
        return pb_path


user_pb_path = get_user_pb_path()
ad_pb_path = get_ad_pb_path()
max_ver = 1.000
last_pb_path = user_pb_path
for pb_path in [user_pb_path, ad_pb_path]:
    vers = glob.glob1(pb_path, 'v*')
    if not vers:
        continue
    folders = [x[1:] for x in vers if x[-1].isdigit()]
    if not folders:
        continue
    last_ver = max(folders)
    if float(last_ver) > float(max_ver):
        max_ver = last_ver
        last_pb_path = pb_path

ins_pb_path = j(last_pb_path, 'v' + str(max_ver))
# print(ins_pb_path)
if ins_pb_path not in sys.path:
    sys.path.insert(0, ins_pb_path)
